'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _soundcloudAudio = require('soundcloud-audio');

var _soundcloudAudio2 = _interopRequireDefault(_soundcloudAudio);

var _Icons = require('./Icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlayButton = function (_Component) {
    _inherits(PlayButton, _Component);

    function PlayButton() {
        _classCallCheck(this, PlayButton);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(PlayButton).apply(this, arguments));
    }

    _createClass(PlayButton, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            var _props = this.props;
            var playing = _props.playing;
            var seeking = _props.seeking;

            return playing !== nextProps.playing || seeking !== nextProps.seeking;
        }
    }, {
        key: 'handleClick',
        value: function handleClick(e) {
            var _props2 = this.props;
            var playing = _props2.playing;
            var soundCloudAudio = _props2.soundCloudAudio;
            var onTogglePlay = _props2.onTogglePlay;


            if (!playing) {
                soundCloudAudio && soundCloudAudio.play({ playlistIndex: soundCloudAudio._playlistIndex });
            } else {
                soundCloudAudio && soundCloudAudio.pause();
            }

            onTogglePlay && onTogglePlay(e);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props;
            var playing = _props3.playing;
            var seekingIcon = _props3.seekingIcon;
            var seeking = _props3.seeking;
            var className = _props3.className;
            var style = _props3.style;


            var iconNode = void 0;
            if (seeking && seekingIcon) {
                iconNode = _react2.default.cloneElement(seekingIcon);
            } else if (playing) {
                iconNode = _react2.default.createElement(_Icons.PauseIconSVG, null);
            } else {
                iconNode = _react2.default.createElement(_Icons.PlayIconSVG, null);
            }

            var classNames = (0, _classnames2.default)('sb-soundplayer-play-btn', className);

            return _react2.default.createElement(
                'button',
                { type: 'button', className: classNames, style: style, onClick: this.handleClick.bind(this) },
                iconNode
            );
        }
    }]);

    return PlayButton;
}(_react.Component);

PlayButton.propTypes = {
    className: _react.PropTypes.string,
    seeking: _react.PropTypes.bool,
    playing: _react.PropTypes.bool,
    onTogglePlay: _react.PropTypes.func,
    seekingIcon: _react.PropTypes.node,
    soundCloudAudio: _react.PropTypes.instanceOf(_soundcloudAudio2.default)
};

PlayButton.defaultProps = {
    playing: false,
    seeking: false
};

exports.default = PlayButton;